#include "Block.h"

void Block::Update(Arduboy2& arduboy, Puck& puck){
  //Checks that block is active first
  if(active){
    //Calculating collisions between puck and blocks
    if(puck.posY >= posY && puck.posY <= posY + 5){
      if(puck.posX >= posX && puck.posX <= posX + 12){
        
        //Hides the block so player has destroyed it
        Hide(arduboy);

        //Makes block inactive to prevent future collisions
        active = false;
        arduboy.drawRect(posX,posY,12,5,BLACK);
        arduboy.drawRect(posX+1,posY,10,4,WHITE);
        
        //Decides which side of the block the puck hit, in order to calculate bounce direction
        if(puck.posY >= posY+0.5 && puck.posY <= posY + 4.5){
          puck.CalcBounceX();
        }else{
          puck.CalcBounceY();
        }
        
      }
    }
  }else{
    switch(destroyAnim){
      case 0:
        arduboy.drawRect(posX+1,posY,10,4,BLACK);
        arduboy.drawRect(posX+2,posY+1,8,3,WHITE);
        destroyAnim++;
        break;
      case 1:
        arduboy.drawRect(posX+2,posY+1,8,3,BLACK);
        arduboy.drawRect(posX+3,posY+1,6,2,WHITE);
        destroyAnim++;
        break;
      case 2:
        arduboy.drawRect(posX+3,posY+1,6,2,BLACK);
        arduboy.drawRect(posX+4,posY+2,4,1,WHITE);
        destroyAnim++;
        break;
      case 3:
        arduboy.drawRect(posX+4,posY+2,4,1,BLACK);
        destroyAnim++;
        break;
    }
  }
  
}

void Block::Display(Arduboy2& arduboy){
  arduboy.drawRect(posX,posY,12,5);
}

void Block::Hide(Arduboy2& arduboy){
  arduboy.drawRect(posX,posY,12,5,BLACK);
}

